/*-
 * ~~~~~~licensing~~~~~~
 * schema-impl
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.registry.schema.resolver.resource;

import org.apache.cxf.resource.ResourceResolver;
import ru.entaxy.esb.system.registry.schema.api.ResourceService;
import ru.entaxy.esb.system.registry.schema.api.entity.Resource;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.Optional;

public class CxfDBResourceResolver implements ResourceResolver {

    private ResourceService resourceService;

    @Override
    public <T> T resolve(String resourceName, Class<T> resourceType) {
        // null - because we need only resource from db
        return null;
    }

    @Override
    public InputStream getAsStream(String name) {
        Optional<Resource> resource = resourceService.getResourceByName(name);
        if (resource.isPresent()) {
            return new ByteArrayInputStream(resource.get().getResourceValue());
        } else {
            Optional<Resource> xsd = resourceService.getResourceByName(name);
            return xsd.map(value -> new ByteArrayInputStream(value.getResourceValue())).orElse(null);
        }
    }

    public ResourceService getResourceService() {
        return resourceService;
    }

    public void setResourceService(ResourceService resourceService) {
        this.resourceService = resourceService;
    }
}
